/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.iam.riam;

import java.util.ArrayList;

import nl.utwente.ewi.hmi.deira.db.BackgroundInformation;
import nl.utwente.ewi.hmi.deira.queue.Event;

/**
 * This class is purely to test the interpret functions of the EventGeneration
 * classes. It is not used in the actual System!
 * 
 * @author Danny
 * @version 0.4 2006-11-06
 * @deprecated Uses Parser instead of Parser2
 */
public class InterpreterTest {

	/**
	 * Run to execute tests.
	 * 
	 * @param args
	 *            N/A
	 */
	public static void main(String[] args) {

		ArrayList<Participant> raceState = new ArrayList<Participant>();
		raceState.add(new Participant(BackgroundInformation.PARTICIPANT[0]));
		raceState.add(new Participant(BackgroundInformation.PARTICIPANT[1]));
		raceState.add(new Participant(BackgroundInformation.PARTICIPANT[2]));
		raceState.add(new Participant(BackgroundInformation.PARTICIPANT[3]));

		int eventCounter = 0;

		long currTime = System.currentTimeMillis();
		long prevTime = currTime - 1000;

		Parser parser = new Parser();
		ArrayList<EventGenerationRule> rules = parser.parse("test.rls");

		/*
		 * // situation 1 // #4 has fallen (speed down and stop) - passed //
		 * large gap between #3 and #4 - passed // #2 speed up - passed // #2
		 * has overtaken #3 - passed // #3 speed up - passed // #1 speed down -
		 * passed // #1 rank during backstretch - passed // #1 top backstretch -
		 * passed // small gap #1 en #2 - passed raceState.get(0).addState(new
		 * State(prevTime, 1160, 30, 1)); raceState.get(0).addState(new
		 * State(currTime, 1200, 20, 1)); raceState.get(1).addState(new
		 * State(prevTime, 1000, 30, 3)); raceState.get(1).addState(new
		 * State(currTime, 1194, 40, 2)); raceState.get(2).addState(new
		 * State(prevTime, 1040, 20, 2)); raceState.get(2).addState(new
		 * State(currTime, 1120, 30, 3)); raceState.get(3).addState(new
		 * State(prevTime, 810, 10, 4)); raceState.get(3).addState(new
		 * State(currTime, 820, 0, 4));
		 */

		/*
		 * // situation 2 - testing: speed up, gap large, finish // #1 speed up
		 * - passed // #2 speed up - passed // #3 speed up - passed // #4 speed
		 * up - passed // gap large #1, #2 - passed // gap large #2, #3 - passed
		 * // gap large #3, #4 - passed // #1 finish (position, time, finish) -
		 * passed, passed, passed raceState.get(0).addState(new State(prevTime,
		 * 1970, 40, 1)); raceState.get(0).addState(new State(currTime, 2000,
		 * 50, 1)); raceState.get(1).addState(new State(prevTime, 1770, 30, 2));
		 * raceState.get(1).addState(new State(currTime, 1800, 40, 2));
		 * raceState.get(2).addState(new State(prevTime, 1570, 20, 3));
		 * raceState.get(2).addState(new State(currTime, 1600, 30, 3));
		 * raceState.get(3).addState(new State(prevTime, 1370, 10, 4));
		 * raceState.get(3).addState(new State(currTime, 1400, 20, 4));
		 */

		/*
		 * // situation 3 - testing: speed down, gap small, final stretch // #1
		 * speed down - passed // #2 speed down - passed // #3 speed down -
		 * passed // #4 speed down - passed // gap small #1 #2 - passed // gap
		 * small #2 #3 - passed // gap small #3 #4 - passed // #1 final stretch
		 * position/ranking - passed, passed raceState.get(0).addState(new
		 * State(prevTime, 1799, 20, 1)); raceState.get(0).addState(new
		 * State(currTime, 1800, 10, 1)); raceState.get(1).addState(new
		 * State(prevTime, 1790, 30, 2)); raceState.get(1).addState(new
		 * State(currTime, 1791, 20, 2)); raceState.get(2).addState(new
		 * State(prevTime, 1781, 40, 3)); raceState.get(2).addState(new
		 * State(currTime, 1782, 30, 3)); raceState.get(3).addState(new
		 * State(prevTime, 1772, 50, 4)); raceState.get(3).addState(new
		 * State(currTime, 1773, 40, 4));
		 */

		/*
		 * // situation 4 - testing: speed stop, overtake // #1, #2, #3, #4
		 * speed stop (& speed down) - passed // #1, #2, #3 overtake - passed //
		 * #1 time, position first half, position backstretch - passed, passed,
		 * passed raceState.get(0).addState(new State(prevTime, 999, 20, 4));
		 * raceState.get(0).addState(new State(currTime, 1001, 0, 1));
		 * raceState.get(1).addState(new State(prevTime, 1790, 30, 1));
		 * raceState.get(1).addState(new State(currTime, 1791, 0, 2));
		 * raceState.get(2).addState(new State(prevTime, 1781, 40, 2));
		 * raceState.get(2).addState(new State(currTime, 1782, 0, 3));
		 * raceState.get(3).addState(new State(prevTime, 1772, 50, 3));
		 * raceState.get(3).addState(new State(currTime, 1773, 0, 4));
		 */

		// situation 5 - terminology: blanket finish, no speed change
		// gap small #1-2, #2-3 - passed
		// time/position: finish, finish - passed
		// terminology - passed
		raceState.get(0).addState(new State(prevTime, 1990, 20, 1));
		raceState.get(0).addState(new State(currTime, 2000, 20, 1));
		raceState.get(1).addState(new State(prevTime, 1990, 30, 2));
		raceState.get(1).addState(new State(currTime, 1997, 30, 2));
		raceState.get(2).addState(new State(prevTime, 1990, 40, 3));
		raceState.get(2).addState(new State(currTime, 1992, 40, 3));
		raceState.get(3).addState(new State(prevTime, 1850, 50, 4));
		raceState.get(3).addState(new State(currTime, 1900, 50, 4));
		for (int i = 0; i < rules.size(); i++) {
			Event event = rules.get(i).interpret(eventCounter, raceState,
					prevTime);
			// if (event != null) eventCounter++
			System.out.println("Event: " + event);
		}

	}

}
