/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.iam.riam;

import java.util.ArrayList;

/**
 * This class is purely to test the parser functions to generate the
 * EventGeneration classes. It is not used in the actual System!
 */
public class ParserTest {

	/**
	 * Run to perform tests.
	 * 
	 * @param args
	 *            N/A
	 */
	public static void main(String[] args) {

		Parser2 parser = new Parser2();

		// test.rls parsing - PASSED
		ArrayList<EventGenerationRule> rules = parser.parse("test.rls");
		for (int i = 0; i < rules.size(); i++) {
			System.out.println(rules.get(i));
		}

		/*
		 * ArrayList<Participant> raceState = new ArrayList<Participant>();
		 * raceState.add(new Participant(BackgroundInformation.PARTICIPANT[0]));
		 * raceState.add(new Participant(BackgroundInformation.PARTICIPANT[1]));
		 * raceState.add(new Participant(BackgroundInformation.PARTICIPANT[2]));
		 * raceState.add(new Participant(BackgroundInformation.PARTICIPANT[3]));
		 * 
		 * // state prev raceState.get(0).addState(new iam.riam.State(1000, 100,
		 * 0, 1)); raceState.get(1).addState(new iam.riam.State(1000, 80, 0,
		 * 2)); raceState.get(2).addState(new iam.riam.State(1000, 60, 0, 3));
		 * raceState.get(3).addState(new iam.riam.State(1000, 40, 0, 4));
		 * 
		 * // state curr raceState.get(0).addState(new iam.riam.State(2000, 200,
		 * 0, 1)); raceState.get(1).addState(new iam.riam.State(2000, 160, 0,
		 * 2)); raceState.get(2).addState(new iam.riam.State(2000, 120, 0, 3));
		 * raceState.get(3).addState(new iam.riam.State(2000, 80, 0, 4));
		 * 
		 * // forced event generation - PASSED RaceEvent e1 =
		 * parser.parseEventText
		 * ("PRESTART;;<>;"+RaceEvent.PRESTART_IMPORTANCE+";"
		 * +RaceEvent.PRESTART_DECAY+";").interpret(1, raceState,
		 * System.currentTimeMillis()); RaceEvent e2 =
		 * parser.parseEventText("START;;<>;"
		 * +RaceEvent.START_IMPORTANCE+";"+RaceEvent
		 * .START_DECAY+";").interpret(2, raceState,
		 * System.currentTimeMillis()); System.out.println();
		 * System.out.println("prestart: " + e1); System.out.println("start: " +
		 * e2);
		 * 
		 * System.out.println();
		 * 
		 * // parameter tests - PASSED e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param1: "
		 * + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<100>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param2: "
		 * + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<100.0>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param3: "
		 * + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<45.54>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param4: "
		 * + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<(1+2)>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param5: "
		 * + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<#1.curr.pos>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("param6: " + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<#1.prev.pos>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("param7: " + e1); e1 =
		 * parser.parseEventText("PARAM;TEST;<>;1.0;0.5;<1,2,3>").interpret(1,
		 * raceState, System.currentTimeMillis()); System.out.println("param8: "
		 * + e1); e1 =parser.parseEventText(
		 * "PARAM;TEST;<>;1.0;0.5;<(#1.curr.pos-#1.prev.pos),(#2.curr.rank+1),(#3.prev.speed*#4.prev.speed)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("param9: " + e1);
		 * 
		 * // interpolate time tests // TODO NOT TESTABLE LIKE THIS SINCE IT
		 * USES SYSTEM TIME! e1 =parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<150, ((((#1.curr.time-#1.prev.time)/(#1.curr.pos-#1.prev.pos) )*( 150-#1.prev.pos )) + #1.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("time1: " + e1); // expected: 1500 e1 =
		 * parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<100, ((((#1.curr.time-#1.prev.time)/(#1.curr.pos-#1.prev.pos) )*( 100-#1.prev.pos )) + #1.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("time2: " + e1); // expected: 1000 e1 =
		 * parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<200, ((((#1.curr.time-#1.prev.time)/(#1.curr.pos-#1.prev.pos) )*( 200-#1.prev.pos )) + #1.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("time3: " + e1); // expected: 2000 e1 =
		 * parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<101, ((((#1.curr.time-#1.prev.time)/(#1.curr.pos-#1.prev.pos) )*( 101-#1.prev.pos )) + #1.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("time4: " + e1); // expected: close to 1000 e1 =
		 * parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<199, ((((#1.curr.time-#1.prev.time)/(#1.curr.pos-#1.prev.pos) )*( 199-#1.prev.pos )) + #1.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("time5: " + e1); // expected: close to 2000
		 * 
		 * // time rounding test - PASSED zolang time <= int !!! // TODO test in
		 * real environment // state prev raceState.get(0).addState(new
		 * iam.riam.State(1234567, 100, 0, 1)); raceState.get(1).addState(new
		 * iam.riam.State(12345678, 80, 0, 2)); raceState.get(2).addState(new
		 * iam.riam.State(123456789, 60, 0, 3)); raceState.get(3).addState(new
		 * iam.riam.State(1234567890, 40, 0, 4)); // state curr
		 * raceState.get(0).addState(new iam.riam.State(1234567+1, 200, 0, 1));
		 * raceState.get(1).addState(new iam.riam.State(12345678+1, 160, 0, 2));
		 * raceState.get(2).addState(new iam.riam.State(123456789+1, 120, 0,
		 * 3)); raceState.get(3).addState(new iam.riam.State(1234567890+1, 80,
		 * 0, 4)); // yrdy e1 =parser.parseEventText(
		 * "TIME;SOMEPOINT;<#1>;1.0;0.5;<(#1.curr.time-#1.prev.time), (#2.curr.time-#2.prev.time), (#3.curr.time-#3.prev.time), (#4.curr.time-#4.prev.time)>"
		 * ).interpret(1, raceState, System.currentTimeMillis());
		 * System.out.println("timer1: " + e1);
		 */

		// goed - should be parsed correctly
		/*
		 * System.out.println("Constants tests"); System.out.println("Test 01: "
		 * + parser.parseEventExpression("1")); // passed
		 * System.out.println("Test 02: " +
		 * parser.parseEventExpression("1.2f")); // passed
		 * System.out.println("Test 03: " + parser.parseEventExpression("1.2"));
		 * // passed System.out.println("Test 04: " +
		 * parser.parseEventExpression("(#1.curr.pos&&1)")); // passed
		 * 
		 * System.out.println("Operators tests"); System.out.println("Test 01: "
		 * + parser.parseEventExpression("(1+2)")); // passed
		 * System.out.println("Test 02: " +
		 * parser.parseEventExpression("(1-2)")); // passed
		 * System.out.println("Test 03: " +
		 * parser.parseEventExpression("(1/2)")); // passed
		 * System.out.println("Test 04: " +
		 * parser.parseEventExpression("(1*2)")); // passed
		 * System.out.println("Test 05: " +
		 * parser.parseEventExpression("(1>2)")); // passed
		 * System.out.println("Test 06: " +
		 * parser.parseEventExpression("(1<2)")); // passed
		 * System.out.println("Test 07: " +
		 * parser.parseEventExpression("(1>=2)")); // passed
		 * System.out.println("Test 08: " +
		 * parser.parseEventExpression("(1<=2)")); // passed
		 * System.out.println("Test 09: " +
		 * parser.parseEventExpression("(1==2)")); // passed
		 * System.out.println("Test 10: " +
		 * parser.parseEventExpression("(1!=2)")); // passed
		 * System.out.println("Test 11: " +
		 * parser.parseEventExpression("(1&&2)")); // passed
		 * System.out.println("Test 12: " +
		 * parser.parseEventExpression("(1||2)")); // passed
		 * 
		 * System.out.println("Nexted expressions tests");
		 * System.out.println("Test 01a: " +
		 * parser.parseEventExpression("(1+(2-3))")); // passed
		 * System.out.println("Test 01b: " +
		 * parser.parseEventExpression("((1+2)-3)")); // passed
		 * System.out.println("Test 01c: " +
		 * parser.parseEventExpression("((1+2)-(3/4))")); // passed
		 * System.out.println("Test 02a: " +
		 * parser.parseEventExpression("(1-(2/3))")); // passed
		 * System.out.println("Test 02b: " +
		 * parser.parseEventExpression("((1-2)/3)")); // passed
		 * System.out.println("Test 02c: " +
		 * parser.parseEventExpression("((1-2)/(3*4))")); // passed
		 * System.out.println("Test 03a: " +
		 * parser.parseEventExpression("(1/(2*3))")); // passed
		 * System.out.println("Test 03b: " +
		 * parser.parseEventExpression("((1/2)*3)")); // passed
		 * System.out.println("Test 03c: " +
		 * parser.parseEventExpression("((1/2)*(3>4))")); // passed
		 * System.out.println("Test 04a: " +
		 * parser.parseEventExpression("(1*(2>3))")); // passed
		 * System.out.println("Test 04b: " +
		 * parser.parseEventExpression("((1*2)>3)")); // passed
		 * System.out.println("Test 04c: " +
		 * parser.parseEventExpression("((1*2)>(3<4))")); // passed
		 * System.out.println("Test 05a: " +
		 * parser.parseEventExpression("(1>(2<3))")); // passed
		 * System.out.println("Test 05b: " +
		 * parser.parseEventExpression("((1>2)<3)")); // passed
		 * System.out.println("Test 05c: " +
		 * parser.parseEventExpression("((1>2)<(3>=4))")); // passed
		 * System.out.println("Test 06a: " +
		 * parser.parseEventExpression("(1<(2>=3))")); // passed
		 * System.out.println("Test 06b: " +
		 * parser.parseEventExpression("((1<2)>=3)")); // passed
		 * System.out.println("Test 06c: " +
		 * parser.parseEventExpression("((1<2)>=(3<=4))")); // passed
		 * System.out.println("Test 07a: " +
		 * parser.parseEventExpression("(1>=(2<=3))")); // passed
		 * System.out.println("Test 07b: " +
		 * parser.parseEventExpression("((1>=2)<=3)")); // passed
		 * System.out.println("Test 07c: " +
		 * parser.parseEventExpression("((1>=2)<=(3==4))")); // passed
		 * System.out.println("Test 08a: " +
		 * parser.parseEventExpression("(1<=(2==3))")); // passed
		 * System.out.println("Test 08b: " +
		 * parser.parseEventExpression("((1<=2)==3)")); // passed
		 * System.out.println("Test 08c: " +
		 * parser.parseEventExpression("((1<=2)==(3!=4))")); // passed
		 * System.out.println("Test 09a: " +
		 * parser.parseEventExpression("(1==(2!=3))")); // passed
		 * System.out.println("Test 09b: " +
		 * parser.parseEventExpression("((1==2)!=3)")); // passed
		 * System.out.println("Test 09c: " +
		 * parser.parseEventExpression("((1==2)!=(3&&4))")); // passed
		 * System.out.println("Test 10a: " +
		 * parser.parseEventExpression("(1!=(2&&3))")); // passed
		 * System.out.println("Test 10b: " +
		 * parser.parseEventExpression("((1!=2)&&3)")); // passed
		 * System.out.println("Test 10c: " +
		 * parser.parseEventExpression("((1!=2)&&(3||4))")); // passed
		 * System.out.println("Test 11a: " +
		 * parser.parseEventExpression("(1&&(2||3))")); // passed
		 * System.out.println("Test 11b: " +
		 * parser.parseEventExpression("((1&&2)||3)")); // passed
		 * System.out.println("Test 11c: " +
		 * parser.parseEventExpression("((1&&2)||(3+4))")); // passed
		 * System.out.println("Test 12a: " +
		 * parser.parseEventExpression("(1||(2+3))")); // passed
		 * System.out.println("Test 12b: " +
		 * parser.parseEventExpression("((1||2)+3)")); // passed
		 * System.out.println("Test 12c: " +
		 * parser.parseEventExpression("((1||2)+(3-4))")); // passed
		 */
		// TODO nog een paar dieper geneste expressies testen
		/*
		 * System.out.println(parser.parseEventExpression("(((3/8)*5)-0.4)"));
		 * // passed
		 * System.out.println(parser.parseEventExpression("(((3/8)*5) - 0.4)"));
		 * // passed
		 */

		// TODO fout - should throw runtime exceptions
		/*
		 * System.out.println("Test5: " + parser.parseEventExpression("(1+2)"));
		 * System.out.println("Test6: " +
		 * parser.parseEventExpression("((1+2)*(2+1))"));
		 * System.out.println("Test7: " +
		 * parser.parseEventExpression("(1/(2-3))"));
		 * System.out.println("Test8: " +
		 * parser.parseEventExpression("((1*2)/2)"));
		 */

		/*
		 * System.out.println("Actors parse tests");
		 * System.out.println("Test 01: " + parser.parseEventActors("<#1>")); //
		 * passed System.out.println("Test 02: " +
		 * parser.parseEventActors("< #2 >")); // passed
		 * System.out.println("Test 03: " + parser.parseEventActors("< #3>"));
		 * // passed System.out.println("Test 04: " +
		 * parser.parseEventActors("<#4 >")); // passed
		 * System.out.println("Test 05: " +
		 * parser.parseEventActors("<#1, #2>")); // passed
		 * System.out.println("Test 06: " +
		 * parser.parseEventActors("< #1, #2, #3>")); // passed
		 * System.out.println("Test 07: " +
		 * parser.parseEventActors("< #1, #2, #3, #4 >")); // passed
		 * System.out.println("Test 08: " +
		 * parser.parseEventActors("< #4, #2, #1, #3 >")); // passed
		 * System.out.println("Test 09: " + parser.parseEventActors("< >")); //
		 * passed System.out.println("Test 10: " +
		 * parser.parseEventActors("<>")); // passed
		 */

		/*
		 * System.out.println("Parse event tests");
		 * System.out.println("Test 01a: " +
		 * parser.parseEvent("SPEED;UP;<#1>;5;1;;")); // passed
		 * System.out.println("Test 01b: " +
		 * parser.parseEvent("SPEED;DOWN;<#2>;5;1;;")); // passed
		 * System.out.println("Test 01c: " +
		 * parser.parseEvent("SPEED;STOP;<#3>;5;1;;")); // passed
		 * System.out.println("Test 02a: " +
		 * parser.parseEvent("GAP;SMALL;<#1,#2>;5;1;;")); // passed
		 * System.out.println("Test 02b: " +
		 * parser.parseEvent("GAP;LARGE;<#2,#3>;5;1;;")); // passed
		 * System.out.println("Test 03: " +
		 * parser.parseEvent("OVERTAKE;;<#3,#4>;5;1;;")); // passed
		 * System.out.println("Test 04a: " +
		 * parser.parseEvent("TIME;QUARTER;<#1>;5;1;;")); // passed
		 * System.out.println("Test 04b: " +
		 * parser.parseEvent("TIME;HALF;<#1>;5;1;;")); // passed
		 * System.out.println("Test 04c: " +
		 * parser.parseEvent("TIME;FINISH;<#1>;5;1;;")); // passed
		 * System.out.println("Test 05a: " +
		 * parser.parseEvent("RANK;1;<#1>;5;1;;")); // passed
		 * System.out.println("Test 05b: " +
		 * parser.parseEvent("RANK;2;<#2>;5;1;;")); // passed
		 * System.out.println("Test 05c: " +
		 * parser.parseEvent("RANK;3;<#3>;5;1;;")); // passed
		 * System.out.println("Test 05d: " +
		 * parser.parseEvent("RANK;4;<#4>;5;1;;")); // passed
		 * System.out.println("Test 06a: " +
		 * parser.parseEvent("POSITION;FIRST TURN;<#1>;5;1;;")); // passed
		 * System.out.println("Test 06b: " +
		 * parser.parseEvent("POSITION;HOMESTRETCH;<#1>;5;1;;")); // passed
		 * System.out.println("Test 06c: " +
		 * parser.parseEvent("POSITION;CLUBHOUSE TURN;<#1>;5;1;;")); // passed
		 * System.out.println("Test 07: " +
		 * parser.parseEvent("PRESTART;;;5;1;;")); // passed
		 * System.out.println("Test 08: " + parser.parseEvent("START;;;5;1;;"));
		 * // passed System.out.println("Test 09: " +
		 * parser.parseEvent("FINISH;;<#1>;5;1;;")); // passed
		 * System.out.println("Test 10: " +
		 * parser.parseEvent("TERMINOLOGY;BLANKET FINISH;<#1, #2, #3>;5;1;;"));
		 * // passed
		 */

		/*
		 * System.out.println("Parse rule tests"); //
		 * System.out.println(parser.parseEventExpression
		 * ("(#1.curr.speed>#1.prev.speed)")); // pass
		 * System.out.println("Test 01: " +parser.parseRule(
		 * "(#1.curr.speed>#1.prev.speed)->SPEED;UP;<#1>;(5-(0.1*#1.curr.pos));2;;"
		 * ));
		 */

	}

}
