/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.iam.riam;

import java.util.ArrayList;

/**
 * Test class to see whether the Tokenizer works correctly.
 */
public class TokenizerTest {

	/**
	 * Loads and tokenizes 'test.rls'. If it works correctly the output should
	 * correspond to the contents of 'test.rls'
	 * 
	 * @param args
	 *            n/a
	 */
	public static void main(String[] args) {
		Tokenizer tok = new Tokenizer();
		tok.load("test.rls");
		ArrayList<ArrayList<Token>> lines = tok.getLines();
		for (ArrayList<Token> line : lines) {
			for (Token token : line) {
				System.out.println("" + token + "\t" + token.getType());
				// test 1: does it match with the script file? PASSED
				// System.out.print("" + token.getType() + "");
				// test 2: does it match with the script file? PASSED
			}
			System.out.println();
		}

	}

}
