package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft balbezit door een gegeven speler aan.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class BallPossessionEvent extends RSEvent{
    /** Constructor */
    public BallPossessionEvent(){
        super(0.02,0.0, "ballpossession", null);    
    }
    
    /** Geeft een nieuw BallPossessionEvent als er sprake is van balbezit. 
     * @return BallPosessionEvent bij balbezit van een speler, anders <code>null</code>
    */
    protected static BallPossessionEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        BallPossessionEvent returnEvent = null;
    	if (eg.getPossession() != null) {
    		returnEvent = new BallPossessionEvent();
    		returnEvent.setRobot1(eg.getLastPossession().getName());
    	}
    	return returnEvent;
    } 
      
}