package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat er al enige tijd niks gebeurt met de bal.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class BoringEvent extends RSEvent{
    /**Constructor */
    public BoringEvent(){
        super(0.0,-0.02, "boring", null);    
    }

    /** Geeft een nieuw BoringEvent als er enige tijd niks gebeurt is.
     * @return BoringEvent of <code>null</code>
    */
        
    public static BoringEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        BoringEvent returnEvent=null;
        Situation sit = sits.get(sits.size()-1);
        final int boreFrames=100;
        boolean isBoring=sits.size() > boreFrames;
        for(int a=sits.size()-1; isBoring && a > sits.size()-boreFrames && a > 0; a--){
            isBoring=noBallMove(sit, sits.get(a));
        }     
        if(isBoring){
            returnEvent=new BoringEvent();
        }
        return returnEvent;
    }
}