package nl.utwente.ewi.hmi.deira.iam.vvciam;

/** 
 * Klasse die de emotionele staat van de commentator bijhoudt.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class EmotionGenerator{

    private double emotion; // emotiewaarde van de commentator
    private double mood; // geeft aan in welke bui de commentator is, varieert van 4 tot 10; hoe hoger de waarde hoe sneller de emotiewaarde daalt.
    
    public EmotionGenerator(double mood){
        emotion = 0.5;    
        this.mood = mood;
    }
    
    /**
     * Methode die de emotiewaarde van de commentator bijwerkt. Deze functie dient aangeroepen te worden bij elke nieuwe spelsituatie. 
     * @param e event dat gebeurd is. Als er geen event gebeurd is null meegeven als parameter.
     * Hoort er een event bij de huidige spelsituatie, dan wordt de emotiewaarde opgehoogd met de bijbehorende waarde.
     * De emotiewaarde daalt standaard met (0.00001 * mood) elk frame.
     * De emotiewaarde heeft een minimum- en maximumwaarde van respectievelijk 0 en 1.
     */
    public void updateStatus(RSEvent e){
        if(e != null){
          if (emotion + e.getEmotion() > 1) {
            emotion = 1;
          } else {
            emotion += e.getEmotion();  
          }
        }
        if (emotion < (0.0001 * mood)) {
          emotion = 0;
        } else {
          emotion -= (0.00001 * mood);    
        }
    }
    
    /**
     *  Levert de hudige emotionele waarde op.
     */
    public double getEmotion(){
        return emotion;
    }   
}