package nl.utwente.ewi.hmi.deira.iam.vvciam;

import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;
import nl.utwente.ewi.hmi.deira.iam.vvciam.text.Text;

/** Event geeft het einde van de wedstrijd aan die niet in gelijkspel is geeindigd.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class EndEvent extends RSEvent{
    
    /**Construct */
    public EndEvent(double priority, double emotion, String type, Text text){
        super(priority,emotion, type, text);
    }
    /**Construct */    
    public EndEvent(){
        super(0.27,0,"end", null);    
    }

    /** Geeft een EndEvent of EndDrawEvent.
     * @return <code>EndDrawEvent</code> bij gelijke stand, anders <code>EndEvent</code>.
     */
    public static RSEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        RSEvent e=null;
        if (match.getGoalDifference() > 0) {
            e = new EndEvent();
            e.setScore(match.getScore());
	        e.setTeam1(match.getWinningTeam());
	        e.setTeam2(match.getLosingTeam());
	    } else {
	    	e = new EndDrawEvent();
	    	e.setScore(match.getScore());
	    }
	    return e;
    }    
    
}