package nl.utwente.ewi.hmi.deira.iam.vvciam;

import java.awt.Point;

/** Deze klasse modeleert een object (robot of ball) op een robosoccer speelveld.
  * Naast De positie bevat een instantie van dit type waardes voor de snelheid, en richting van het FieldObject.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */
  
public class FieldObject extends Point{
    private double speed=0;
    private double direction=0;       // te moeilijk om betrouwbaar te berekenen met de beschikbare data!?
    private double xMovement=0;
    private double yMovement=0;
    
  
    /** Creert een nieuw FieldObject met de gegeven x en y coordinaat
    */    
    public FieldObject(int x, int y){
        super(x, y);
        this.speed=0;
        this.direction=0;
    }
    
    /** Zet de richting waarin dit object zich beweegt.
    */
    public void setdirection(double direction){
    	this.direction = direction;        
    }
    
    /** Zet de speed voor dit object.
    */
    public void setSpeed(double speed){
        this.speed=speed;    
    }
    
    /** Geeft de richting waarin de Object zich beweegt.
     * Deze functie is in de praktijk totaal ONBETROUWBAAR!
    */         
    public double getdirection(){
        return direction;
    }
    
    /** Geeft de snelheid waarin dit Object beweegt.
     *  Deze waarde is alleen betrouwbaar na een aanroep van calculateArrayListData!
     */
    public double getSpeed(){
        return speed;
    }
    
    /** Deze functie vergelijkt dit FieldObject met een eerder FieldObject en berekent daaruit een snelheid.
     *  De berekende snelheid is in feite de afstand tussen de 2 FieldObjecten.
     *  Pas na het aanroepen van deze functie heeft de funcite getSpeed() zin.
    */
    public void calculateArrayListData(FieldObject old){
        yMovement=y-old.y;
        xMovement=x-old.x;
        speed=Math.sqrt(((old.x-x)*(old.x-x))+((old.y-y)*(old.y-y)));
    }
    
    /** Geeft aan of 2 FieldObjecten in dezelfde richting bewegen
        NIET BETROUWBAAR GENOEG?    
    @param old Fieldobject om dit FieldObject tegen te vergelijken
    @param maxDifference de maximale afwijking in de x en y richting waarbij nog true wordt gegeven (voorbeeld: 4)    
    @return Geeft true als beide FieldObjecten globaal in dezelfde richting bewegen.
            Wanneer het onduidelijk is in welke richting 1 van beide objecten beweegt, of wanneer ze in verschillende richtingen bewegen geeft deze functie false.
    @requires calculateArrayListData() dient op zowel dit FieldObject, als op de parameter reeds aangeroepen te zijn.
    */
/*    public boolean sameDirection(FieldObject old, int maxDifference){
        boolean ret=true;
        ret = ret && Math.abs(old.xMovement-xMovement) <= maxDifference;
        ret = ret && Math.abs(old.yMovement-yMovement) <= maxDifference;

        return ret;
    }
  */  
}