package nl.utwente.ewi.hmi.deira.iam.vvciam;

import java.awt.geom.Area;

import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;


/** Event geeft aan dat alles in positie staat om een freeball te nemen.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class FreeBallEvent extends RSEvent{
    /** Constructor */
    public FreeBallEvent(){
        super(0.5,0.01,"freeball", null);
    }
    
    /* Checkt of er momenteel een freeball is. 
     * @return is er een freeballevent gaande, dan return ie een <code>FreeBallEvent</code>, anders <code>null</code>.
    */
    public static FreeBallEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg) {
        Situation sit=sits.get(sits.size()-1);
        FreeBallEvent returnEvent=null;
        boolean isFreeball=false;
        for(int i=0; i< 4 && !isFreeball; i++){
            isFreeball=around(eg.freeballPosition[i],eg.areaWidth).contains(sit.getBall());
            for(int a=sits.size()-1; isFreeball && a > sits.size()-5 && a > 0; a--){
                isFreeball=noBallMove(sit, sits.get(a));
                Area tar =(Area)eg.quarter[i].clone();                 
                tar.subtract(eg.goalArea[i/2]);
                isFreeball=isFreeball && numPlayers(sits.get(a), tar) == 2;
                isFreeball=isFreeball && numPlayers(sits.get(a), around(eg.freeballRobotPosition[i][0], eg.areaWidth)) == 1;
                isFreeball=isFreeball && numPlayers(sits.get(a), around(eg.freeballRobotPosition[i][1], eg.areaWidth)) == 1;
            }    
            if(isFreeball){
                returnEvent=new FreeBallEvent();
            }
        }
        return returnEvent;
    }    
}