package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat de bal in het doel ligt.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class GoalEvent extends RSEvent{
    /** Constructor */
    public GoalEvent(double emotion, String type){
        super(1.0,emotion, type, null);    
    }
    
    /** Kijkt of er sprake is van een doelpunt, en geeft al dan niet een OwnGoalEvent, GoalEvent of null terug.
     * @return Als de bal in het doel ligt  en het is een eigen doelpunt: <code>OwnGoalEvent</code> reguliere goal: <code>GoalEvent</code>, anders: <code>null</code>. 
    */
    protected static GoalEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        GoalEvent returnEvent=null;
        Situation sit = sits.get(sits.size()-1);
        int team=-1;
        if(eg.goal[0].contains(sit.getBall())){
            team=1;   
        } else if (eg.goal[1].contains(sit.getBall())){
            team=0;
        }
        
        if(team != -1 ){
	        int goalDifference = match.getGoalDifference(team);
	        double emotion = goalDifference > 20 ? 0 : (0.20 - (0.01*goalDifference));
	        emotion += (match.getTime()*0.00001);
            returnEvent=new GoalEvent(emotion, "goal");
            returnEvent.setTeam1(team == 0 ? match.getTeam1().getName() : match.getTeam2().getName());
            returnEvent.setTeam2(team == 0 ? match.getTeam2().getName() : match.getTeam1().getName());
            returnEvent.setRobot1(eg.getLastPossession().getName());
            returnEvent.setRobot2(eg.getPreLastPossession().getName());
            String scoringteam = returnEvent.getTeam1();
    	    String scoringrobot= returnEvent.getRobot1();
    	    if ((match.getTeam1().getName().equals(scoringteam) && match.getTeam2().contains(scoringrobot)) ||
    	    	(match.getTeam2().getName().equals(scoringteam) && match.getTeam1().contains(scoringrobot))) {
    	    	returnEvent = new OwnGoalEvent(returnEvent.getEmotion());
    	    	returnEvent.setTeam1(team == 0 ? match.getTeam1().getName() : match.getTeam2().getName());
            	returnEvent.setTeam2(team == 0 ? match.getTeam2().getName() : match.getTeam1().getName());
           	returnEvent.setRobot1(eg.getLastPossession().getName());
            	returnEvent.setRobot2(eg.getPreLastPossession().getName());
    	    }
    	}
        return returnEvent;
    }
}