package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat alles in positie staat om een goalkick te nemen.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class GoalKickEvent extends RSEvent{
    /**Constructor */
    public GoalKickEvent(String team1){
        super(0.3,0.0, "goalkick", null);
        this.team1=team1;    
        
    }    
    
    /** Geeft een nieuw GoalKickEvent, als alles klaar staat voor een goalkick.
      * @return als alles in een goalkick opstelling staat: <code>GoalKickEvent</code>, anders: <code>null</code>.
      */
    protected static GoalKickEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        GoalKickEvent returnEvent = null;
        Situation sit = sits.get(sits.size()-1);
        boolean isGoalKick=false;
        for(int i=0; i< 2 && !isGoalKick; i++){
            isGoalKick=eg.goalArea[i].contains(sit.getBall());
            for(int a=sits.size()-1; isGoalKick && a > sits.size()-30 && a > 0; a--){
                isGoalKick=noBallMove(sit, sits.get(a));
                isGoalKick=isGoalKick && (numPlayers(sits.get(a), eg.goalArea[i]) == 1);
            }  
            if(isGoalKick){ 
                String team1=(i == 0 ? match.getTeam1().getName() : match.getTeam2().getName());
                returnEvent = new GoalKickEvent(team1);
            }
        }
        return returnEvent;
    }
}