package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat alles is opgesteld voor een aftrap.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class KickOffEvent extends RSEvent{
    /** Constructor */
    public KickOffEvent(){
        super(0.2,0.0, "kick-off", null);    
    }   
    
    /** Kijkt of er een aftrap plaats vind, en zo ja geeft een KickOffEvent.
     *  @return Als alles is opgesteld voor een aftrap: <code>KickOffEvent</code>, anders: <code>null</code>
     */
    protected static KickOffEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        KickOffEvent returnEvent=null;
        Situation sit = sits.get(sits.size()-1);
        boolean isKickOff= around(eg.centerPoint, eg.areaWidth).contains(sit.getBall());
            for(int a=sits.size()-1; isKickOff && a > sits.size()-30 && a > 0; a--){
                isKickOff=noBallMove(sit, sits.get(a));
            }    
            if(isKickOff){
                returnEvent=new KickOffEvent();
                returnEvent.setScore(match.getScore()); 
                returnEvent.setRobot1(eg.getLastPossession().getName());
            }     
        return returnEvent;
    }
}