package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat een speler een pass gegeven heeft.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class PassEvent extends RSEvent{
    /**Constructor*/
    public PassEvent(){
        super(0.1,0,"pass", null);
    }
    /** Kijkt of er een pass gegeven is, en zo ja geeft een PassEvent.
     *  @return bij een pass: <code>PassEvent</code>, anders: <code>null</code>
     */
    protected static PassEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        PassEvent returnEvent=null;
        boolean isPass=sits.size() >= 5;
        for(int a=sits.size()-1; isPass && a > sits.size()-5 && a > 0; a--){
            isPass=sits.get(a).getBall().getSpeed() > 25;
        }     
        if(isPass){
            returnEvent=new PassEvent();
            returnEvent.setRobot1(eg.getLastPossession().getName());
        }
        return returnEvent;
    }
    
}