package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat alles is opgesteld voor een penalty.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class PenaltyKickEvent extends RSEvent{
    /**Constructor */
    public PenaltyKickEvent(double emotion){
        super(0.9, emotion, "penaltykick", null);    
    }
    /**Constructor */    
    public PenaltyKickEvent(double emotion, String team1){
        super(0.9, emotion, "penaltykick", null);
        this.team1=team1;
    }
    
    /** kijkt of er sprake is van een penalty en zo ja geeft een <code>PenaltyKickEvent</code>
     *  @return Als alles is opgesteld voor een te nemen penalty: <code>PenaltyKickEvent</code>, anders: <code>null</code>
     */    
    
    protected static PenaltyKickEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        PenaltyKickEvent returnEvent=null;
        Situation sit = sits.get(sits.size() -1);
        boolean isPenaltyKick=false;
        for(int i=0; i< 2 && !isPenaltyKick; i++){
            isPenaltyKick=around(eg.penaltyPosition[i], eg.areaWidth).contains(sit.getBall());
            for(int a=sits.size()-1; isPenaltyKick && a > sits.size()-30 && a > 0; a--){
                isPenaltyKick=noBallMove(sit, sits.get(a));
                isPenaltyKick=isPenaltyKick && (numPlayers(sits.get(a), eg.side[i]) == 2);
            }    
            if(isPenaltyKick){
		        int goalDifference = match.getGoalDifference(0);
		        double emotion = goalDifference > 16 ? 0 : (0.08 - (0.005*goalDifference));
		        emotion += (match.getTime()*0.00001); 
                returnEvent=new PenaltyKickEvent(emotion);
            }
        }
        return returnEvent;
    }
}