package nl.utwente.ewi.hmi.deira.iam.vvciam;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;

/** Event geeft aan dat een speler een schot richting doel gedaan heeft.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class ShotOnTargetEvent extends RSEvent{
    /**Constructor*/
    public ShotOnTargetEvent(){
        super(0.7,0.01, "shotontarget", null);    
    }
    
    /** Kijkt of er op dit moment sprake is van een schot op doel.
     *  @return Als er een schot op doel is: <code>ShotOnTargetEvent</code>, anders: <code>null</code>
     */
         
    protected static ShotOnTargetEvent checkEvent(MatchTracker match, java.util.List<Situation> sits, EventGenerator eg){
        ShotOnTargetEvent returnEvent = null;
	    boolean isShot=sits.size() >= 6;
	    if (isShot) {
	    	boolean highSpeed = true;
	    	int sitnr=sits.size()-1;
	        for(int a = sitnr; highSpeed && isShot && a > sits.size()-4 && a > 0; a--){
	        	highSpeed = sits.get(a).getBall().getSpeed() > 20;
	        }
	        FieldObject currentBall = sits.get(sitnr).getBall();
	        FieldObject prevBall = sits.get(sitnr - 2).getBall();  
	        double ycoor = 0;
	        if (prevBall.getX() > currentBall.getX() && eg.side[0].contains(currentBall) && match.getTeam(1).contains(eg.getLastPossession().getName())) {
	        	ycoor= (currentBall.getY()-prevBall.getY())/(prevBall.getX()-currentBall.getX())*currentBall.getX()+currentBall.getY();
		    } else if (prevBall.getX() < currentBall.getX() && eg.side[1].contains(currentBall)&& match.getTeam(0).contains(eg.getLastPossession().getName())) {
			    ycoor = (currentBall.getY()-prevBall.getY())/(currentBall.getX()-prevBall.getX())*(2200 - currentBall.getX())+currentBall.getY();
		    }
		    isShot = (ycoor > 500 && ycoor < 1300);
	        if(isShot && highSpeed){
	    	    returnEvent = new ShotOnTargetEvent();
	    	    returnEvent.setRobot1(eg.getLastPossession().getName());
	    	    if (eg.getPreLastPossession() != null) {
	    		    returnEvent.setRobot2(eg.getPreLastPossession().getName());
	    	    }
	    	}
    	}
    	return returnEvent;
    }
    
}