package nl.utwente.ewi.hmi.deira.iam.vvciam;


/**Deze klasse modelleert een spelsituatie
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class Situation{
    private int moment;
    private FieldObject ball;
    private FieldObject[][] robots;
    
/** Constructor van Situation.
 * @param moment moment van het huidige Situation. Gemeten in aantal voorgaande Situation.
 * @param ball de bal
 * @param robots een 2 bij 5 array van FieldObjects met de robots van beide teams.
*/

    public Situation(int moment, FieldObject ball, FieldObject[][] robots){
        this.moment=moment;
        this.ball=ball;
        this.robots=robots;
    }
    
   /**Functie die op de ball en de robots de functie calculateArrayListData aanroept met als argument het vergelijkebare FieldObject uit old.
    * @param referentie Situation tenopzichte waarvan de berekeningen worden gedaan.
    */    
    public void calculateArrayListData(Situation old){
        ball.calculateArrayListData(old.ball);
        for(int a=0; a<2; a++){
            for(int b=0; b<5; b++){
                robots[a][b].calculateArrayListData(old.robots[a][b]);
            }
        }    
    }

    /** Geeft de ball als een FieldObject.
    */
    public FieldObject getBall(){
        return ball;    
    }
  
    /** Geeft een robot als FieldObject.
     * @param team 0 of 1.
     * @param robit 0...4
     */
    public FieldObject getRobot(int team, int robot){
        return robots[team][robot]; 
    }  
    
    /** Geeft het moment waarop deze Situation betrekking heeft.
     * @return moment het moment in frames sinds het begin van de data.
    */
    public int getMoment(){
        return moment;
    }
}