package nl.utwente.ewi.hmi.deira.iam.vvciam.match;

/**
 * Deze klasse modeleert een Robosoccer team.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */

public class Team {
	
	private String teamname;
	private Robot[] players;

	/**
	 * Constructor van de klasse Team
	 * deze maakt een nieuw Team aan van vijf Robot objecten
	 * @param name, de naam van het team
	 * @param a,b,c,d,e. De vijf Robot objecten die in dit team zitten 
	 */
	public Team(String name,Robot a, Robot b, Robot c, Robot d, Robot e){
		teamname = name;
		players = new Robot[5];
		players[0] = a;
		players[1] = b;
		players[2] = c;
		players[3] = d;
		players[4] = e;
	}

    /** Geeft Robot met betreffende nummer.
      * @param numberOfRobot nummer van de robot: 0 t/m 4
      */
	public Robot getRobot(int numberOfRobot){
		return players[numberOfRobot];
	}
	/** Geeft aan of een bepaalde speler in dit team voorkomt.
	  * @param name de naam van de gezochte Robot.
	  * @return true als dit team een Robot met betreffende naam heeft. Anders: false.
	  */
	public boolean contains(String name){
	    boolean bevat = false;
	    for(int i=0; i<5 && !bevat; i++){
	        bevat = players[i].getName().equals(name);
	    }
	    return bevat;
	}

    /** Geeft de teamnaam
     */
	public String getName(){
		return teamname;
	}
}