package nl.utwente.ewi.hmi.deira.iam.vvciam.visualizer;


import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import nl.utwente.ewi.hmi.deira.iam.vvciam.match.MatchTracker;
import nl.utwente.ewi.hmi.deira.iam.vvciam.match.Team;


/** Score creert een venster waarin de speeltijd en stand worden weergegeven.
 * Deze klasse dient als Observer aan een {@link analyzer.MatchTracker match} class worden toegevoegd. De score wordt uit de Matchklasse gehaald.
 * @version
 * @author Buursma, Hendriksen, Ten Hoeve, Van der Kooi
 */
public class Score extends JFrame implements Observer{
	
	private MatchTracker m;
	private JPanel p1;
	private JPanel p2;
	private JPanel p3;
	private JPanel p4;
	private JPanel p5;
	private JLabel[] scoreTeams=new JLabel[2];
	private JLabel streepje;
    	private JLabel team1name;
    	private JLabel team2name;
    	private JLabel currenttime;
	
    /** Creeert een nieuw Score-object.
     * @param m Hieruit worden de teamname uitgelezen.
    */	
	public Score(MatchTracker m){
	    this.m=m;
	    Team team1=m.getTeam1();
	    Team team2=m.getTeam2();
	    setTitle("The score is :");
	    setDefaultCloseOperation(EXIT_ON_CLOSE); 
	    p1 = new JPanel(new GridLayout(1,1));
	    currenttime = new JLabel("00:00");
	    scoreTeams[0]=new JLabel("0");
	    scoreTeams[0].setHorizontalAlignment(4);
	    scoreTeams[1]= new JLabel("0");
	    streepje = new JLabel("-");
	    streepje.setHorizontalAlignment(0);
	    team1name = new JLabel(team1.getName());
	    team1name.setForeground(Color.BLUE);
	    team1name.setHorizontalAlignment(4);
	    team2name = new JLabel(team2.getName());
	    team2name.setForeground(Color.RED);
	    p1.add(team1name);
	    p2 = new JPanel(new GridLayout(1,3));
	    p3 = new JPanel(new GridLayout(1,1));
	    p2.add(scoreTeams[0]);
	    p2.add(streepje);
	    p2.add(scoreTeams[1]);
	    p3.add(team2name);
	    p4 = new JPanel(new GridLayout(1,3));
	    p4.add(p1);
	    p4.add(p2);
	    p4.add(p3);
	    p5 = new JPanel(new FlowLayout());
	    p5.add(currenttime);
	    Container c = getContentPane();
	    c.setLayout(new GridLayout(2,1));
	    c.add(p4);
	    c.add(p5);
	    setLocation(100,100);
	    setSize(300,100);  
	    setVisible(true);
	    setResizable(false);
    }
    
    /** Methode die de klok op het scorebord bijwerkt
     * @param thetime de huidige tijd in seconden
     */
    private void timeUpdate(int thetime){
        int a = thetime/60;
        int b = thetime%60;
        String c =Integer.toString(a); 	
        String d =Integer.toString(b);
        if (b<10){        	
            currenttime.setText(c+ ":0" + d);
        } else{        	
        	currenttime.setText(c+ ":" + d);
        }
        repaint();        	
    }
    
    /** Methode wordt aangeroepen door een Match object bij elke wijziging in de speeltijd en/of stand.
      * @param arg null
     */
    public void update(Observable o, Object arg){
        if(o instanceof MatchTracker){
            MatchTracker m= (MatchTracker) o;
            timeUpdate(m.getTime());
            scoreTeams[0].setText(Integer.toString(m.getScore1()));
            scoreTeams[1].setText(Integer.toString(m.getScore2()));
        }
    }
    	          
}
	