/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.queue;

public class HREventFilter extends EventFilter {

	private EventQueue queue;

	/**
	 * @param queue
	 */
	public HREventFilter(EventQueue queue) {
		super();
		this.queue = queue;
	}

	@Override
	public void doFilter(Event e) {
		// if event type = overtake -> update involved ranking events
		// yup hardcoded, not pretty...
		if (e.getType().equals("OVERTAKE")) {
			// ArrayList<Participant> ps = e.getActors();
			String l = e.getLabel();
			if (l.equals("1")) {
				// actors #1, #2
				// updateRankingEvent(ps.get(0), "1");
				// updateRankingEvent(ps.get(1), "2");
				queue.deleteEvent("RANK", "1");
				queue.deleteEvent("RANK", "2");
			} else if (l.equals("2")) {
				// actors #2, #3
				// updateRankingEvent(ps.get(0), "2");
				// updateRankingEvent(ps.get(1), "3");
				queue.deleteEvent("RANK", "2");
				queue.deleteEvent("RANK", "3");
			} else if (l.equals("3")) {
				// actors #3, #4
				// updateRankingEvent(ps.get(0), "3");
				// updateRankingEvent(ps.get(1), "4");
				queue.deleteEvent("RANK", "3");
				queue.deleteEvent("RANK", "4");
			}
		}
	}

}
