/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.queue;

import java.util.ArrayList;

import nl.utwente.ewi.hmi.deira.iam.riam.Participant;

public class RaceEventTest {

	/**
	 * Run to test class RaceEvent.
	 * 
	 * @param args
	 *            N/A
	 */
	public static void main(String[] args) {
		Event e1;
		Event e2;
		Participant p1 = new Participant("Azure");
		Participant p2 = new Participant("Eben");
		ArrayList<Participant> ps1 = new ArrayList<Participant>();
		ArrayList<Participant> ps2 = new ArrayList<Participant>();
		ArrayList<Participant> ps3 = new ArrayList<Participant>();
		ps1.add(p1);
		ps2.add(p1);
		ps2.add(p2);
		ps3.add(p2);

		// Test: isSimilar
		// type different, label equal, actors equal (null)
		e1 = new HREvent(1, 0, "A", "1", null, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "B", "1", null, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1a: FAILED");
		else
			System.out.println("Test1a: PASSED");
		// type equal, label different, actors equal (null)
		e1 = new HREvent(1, 0, "A", "1", null, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "A", "2", null, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1b: FAILED");
		else
			System.out.println("Test1b: PASSED");
		// type equal, label equal, actors equal (null)
		e1 = new HREvent(1, 0, "A", "1", null, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "A", "1", null, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1c: PASSED");
		else
			System.out.println("Test1c: FAILED. e1 = " + e1 + "; e2 = " + e2);
		// type equal, label equal, actors really equal
		e1 = new HREvent(1, 0, "A", "1", ps1, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "A", "1", ps1, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1d: PASSED");
		else
			System.out.println("Test1d: FAILED. e1 = " + e1 + "; e2 = " + e2);
		// type equal, label equal, actors really different
		e1 = new HREvent(1, 0, "A", "1", ps1, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "A", "1", ps2, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1e: FAILED");
		else
			System.out.println("Test1e: PASSED");
		e1 = new HREvent(1, 0, "A", "1", ps1, 5.0f, 0, null);
		e2 = new HREvent(1, 0, "A", "1", ps3, 5.0f, 0, null);
		if (e1.isSimilar(e2))
			System.out.println("Test1f: FAILED");
		else
			System.out.println("Test1f: PASSED");
	}

}
