/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.queue;

import java.util.HashMap;

public class VSEvent extends Event {

	private String text;

	/**
	 * 
	 * @param label
	 * @param importance
	 * @param decay
	 */
	public VSEvent(String text, int id, long time, String type, String label,
			float importance, float decay) {
		super(id, time, type, label, importance, decay);
		this.text = text;
	}

	@Override
	/**
	 * 
	 */
	public boolean isSimilar(Event e) {
		return false; // We don't want events to be similar. If they're
						// generated, they should be outputted.
	}

	/**
	 * 
	 * @return
	 */
	public HashMap<String, String> getVSparams() {
		return new HashMap<String, String>();
	}

	public void setText(String text) {
		this.text = text;
	}

	public String getText() {
		return text;
	}

}