/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.tgm;

public class EmotionalBoundPair {

	private final String emotionName;
	private float lowerBound;
	private float upperBound;

	public EmotionalBoundPair(String emotionName, float lowerBound,
			float upperBound) {
		super();
		this.emotionName = emotionName;
		this.lowerBound = lowerBound;
		this.upperBound = upperBound;
	}

	public EmotionalBoundPair(String boundsstring) {
		// =-- Of the form: emotionName=lowerbound-upperbound
		emotionName = boundsstring.substring(0, boundsstring.indexOf('='));
		lowerBound = Float.parseFloat(boundsstring.substring(boundsstring
				.indexOf('=') + 1, boundsstring.indexOf('-')));
		upperBound = Float.parseFloat(boundsstring.substring(boundsstring
				.indexOf('-') + 1));

	}

	public String getEmotionName() {
		return emotionName;
	}

	public float getLowerBound() {
		return lowerBound;
	}

	public float getUpperBound() {
		return upperBound;
	}

	public void setLowerBound(float newBound) {
		lowerBound = newBound;
	}

	public void setUpperBound(float newBound) {
		upperBound = newBound;
	}

	public float getCenter() {
		float center = lowerBound + (upperBound - lowerBound) / 2;
		return center;
	}

	public boolean equals(Object other) {
		boolean match = true;

		if (other instanceof EmotionalBoundPair) {
			EmotionalBoundPair otherPair = (EmotionalBoundPair) other;

			if (!emotionName.equals(otherPair.getEmotionName())) {
				return false;
			}
			if (lowerBound != otherPair.getLowerBound()
					|| upperBound != otherPair.getUpperBound()) {
				return false;
			}

		} else
			return false;

		return match;
	}

}