/* 
 * Copyright (C) 2009 HMI Group, University of Twente.
 *
 * @author Franois L.A. Knoppel <[alias] francois [on server at] knoppel.nl>
 * @author Almer S. Tigelaar <[alias] almer [on server at] gnome.org>
 * @author Danny Oude Bos <[alias] d.oudebos [on server at] utwente.nl>
 * @author Thijs Alofs <[alias] t.alofs [on server at] alumnus.utwente.nl>
 *
 * This file is part of the DEIRA project, which is free software; you can redistribute it
 * and/or modify it under the terms of the GNU "Lesser" General Public License v3 as published by the 
 * Free Software Foundation.
 */

package nl.utwente.ewi.hmi.deira.tgm;

/**
 * Container class for production rule tokens.
 */
public class RuleToken {

	/**
	 * Type definitions
	 */
	final static int PRODUCTION = 0;
	final static int PARAMETER = 1;
	final static int LITERAL = 2;
	final static int CONDITION = 3;

	/**
	 * Instance variables
	 */
	private int type;
	private String text;

	/**
	 * Constructor for the class RuleToken. Assigns the parameters to the
	 * instance variables.
	 * 
	 * @param text
	 *            The identifier of this rule token.
	 * @param type
	 *            The type of this token.
	 */
	public RuleToken(String text, int type) {
		this.text = text;
		this.type = type;
	}

	/**
	 * @return Returns the text.
	 */
	public String getText() {
		return text;
	}

	/**
	 * @param text
	 *            The text to set.
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @return Returns the type.
	 */
	public int getType() {
		return type;
	}

	/**
	 * @param type
	 *            The type to set.
	 */
	public void setType(int type) {
		this.type = type;
	}

}
